/*
 *
 *   Copyright (C) 2005-2009 by Raymond Huang
 *   plushuang at users.sourceforge.net
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 *  ---
 *
 *  In addition, as a special exception, the copyright holders give
 *  permission to link the code of portions of this program with the
 *  OpenSSL library under certain conditions as described in each
 *  individual source file, and distribute linked combinations
 *  including the two.
 *  You must obey the GNU Lesser General Public License in all respects
 *  for all of the code used other than OpenSSL.  If you modify
 *  file(s) with this exception, you may extend this exception to your
 *  version of the file(s), but you are not obligated to do so.  If you
 *  do not wish to do so, delete this exception statement from your
 *  version.  If you delete this exception statement from all source
 *  files in the program, then also delete it here.
 *
 */

#ifndef UG_BATCH_WIDGET_H
#define UG_BATCH_WIDGET_H

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct UgBatchWidgetT		UgBatchWidget;

struct UgBatchWidgetT {
	GtkWidget*	self;

	GtkWidget*	entry;
	GtkWidget*	radio_button;
	GtkWidget*	spin_from;
	GtkWidget*	spin_to;
	GtkWidget*	label_to;
	GtkWidget*	digits_label;
	GtkWidget*	digits_spin;
	GtkWidget*	label_case;
	GtkWidget*	entry_a;
	GtkWidget*	entry_z;

	GtkTreeView*	preview;
	GtkListStore*	preview_list;
};

void		ug_batch_widget_init (UgBatchWidget* bwidget);
gboolean	ug_batch_widget_update_preview (UgBatchWidget* bwidget);
GList*		ug_batch_widget_get_list (UgBatchWidget* bwidget, gboolean preview_only);

#ifdef __cplusplus
}
#endif

#endif  // End of UG_BATCH_WIDGET_H

